/*Includes ----------------------------------------------*/
#include "system.h"
#include "ble_comm.h"
#include "bsp_time.h"
#include "hal_ble_host.h"
#include "hal_ble_client.h"
#include "hal_ble_common.h"
#include "app_flash.h"
#include "app_game.h"
#include "app_data_transfer.h"
#include "app_step.h"

/*Local Functions ------------------------------------------------------------------------------------------------------------------------------------*/
static void app_data_transfer_Process(void)
{
	static uint32_t tim 	= 0;
	static uint32_t	tim2 	= 0;
	static uint8_t	flag 	= 0;
	//ȫģʽ
	if(app_game_GetGameMode() || app_step_Real_Get())
	{
		if(!flag){flag =1;
			Process_SetHoldOn(app_data_transfer_Process,1);
		}
		if(TIME_GetTicks()-tim>=500){tim = TIME_GetTicks();
			if( 0 == slave_isconnect()){
//				DEBUG_LOG("app_data_transfer_Process advertising_start\r\n");
				advertising_stop();
				advertising_start();
			}
			if(mFlash.isHost && 0 == host_isconnect())scan_start();
		}

		if(TIME_GetTicks()-tim2>=3){tim2 = TIME_GetTicks();	
			IMU_Dtalige();
		}			
	}
	else{
		if(flag){flag =0;
			Process_SetHoldOn(app_data_transfer_Process,0);
		}
	}
}


/*API -------------------------------------------------------*/
/**
	@brief 		ɰ汾IMU_SetSlaveData(uint8_t* pdat,uint8_t len)д
	@param 		pdat	
	@param 		len		
	@return 	
*/
void app_data_transfer_set_SlaveData(uint8_t* pdat,uint8_t len)
{
	if(pdat[3]==BLE_TRACK){
		IMU_Rec_data(pdat,len);
	}
	app_game_SetClientGameMode();
}
/**
	@brief 		ʼݴӦ
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_data_transfer_Init(void)
{
	//ݴ߳
	Process_Start(0,"data_transfer",app_data_transfer_Process);
	
	BLE_Host_Rx_Regist_Game(app_data_transfer_set_SlaveData);
	
	return 0;
}

void send_protocol(uint8_t index,uint8_t cmd,uint8_t* p,uint8_t datLen)
{
	BLE_Client_Tx_Send(0,(BLE_CMD_n)cmd,p,datLen);
}	





