#ifndef __HAL_DETECT_LEFT_RIGHT_H__
#define __HAL_DETECT_LEFT_RIGHT_H__

#ifdef __cplusplus
extern "C" {
#endif

/*Includes ------------------------------------------------------*/
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"
#include "drv_qma7981.h"

typedef enum{
	QMA_OFF,
	QMA_12_5HZ,
	QMA_104HZ,
}QmaFrequency;

/*API -------------------------------------------------------*/
/**
	@brief 		ʼЬ
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	hal_qma_Init(void);

/**
	@brief 		رQMAĵԴ
	@param 		
	@return 	
**/
void hal_qma_close(void);

/**
	@brief 	  QMAĹƵ
	@param 		qmaٶȵĹƵ
	@return 	
**/

void hal_qma_setFrequency(QmaFrequency freq);

/**
	@brief 	  QMAĹƵ
	@param 		
	@return 	qmaٶȵĹƵ
**/
QmaFrequency hal_get_QmaFrequency(void);

#ifdef __cplusplus
}
#endif

#endif



























