#ifndef __drv_iic_front_h__
#define __drv_iic_front_h__

#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"
#include "nrf_gpio.h"

#define		IIC_FRONT_SCL_SET		nrf_gpio_pin_write(PIN_QMC_LSM_FRONT_SCL,1)
#define		IIC_FRONT_SCL_CLR		nrf_gpio_pin_write(PIN_QMC_LSM_FRONT_SCL,0)
#define		IIC_FRONT_SDA_SET		nrf_gpio_pin_write(PIN_QMC_LSM_FRONT_SDA,1)
#define		IIC_FRONT_SDA_CLR		nrf_gpio_pin_write(PIN_QMC_LSM_FRONT_SDA,0)
#define		IIC_FRONT_SDA_READ	nrf_gpio_pin_read(PIN_QMC_LSM_FRONT_SDA)

//#define		IIC_FRONT_SCL_SET		nrf_gpio_pin_write(PIN_QMC_BACK_SCL,1)
//#define		IIC_FRONT_SCL_CLR		nrf_gpio_pin_write(PIN_QMC_BACK_SCL,0)
//#define		IIC_FRONT_SDA_SET		nrf_gpio_pin_write(PIN_QMC_BACK_SDA,1)
//#define		IIC_FRONT_SDA_CLR		nrf_gpio_pin_write(PIN_QMC_BACK_SDA,0)
//#define		IIC_FRONT_SDA_READ	nrf_gpio_pin_read(PIN_QMC_BACK_SDA)

void IIC_FRONT_Init(void);
bool IIC_FRONT_WriteBytes(uint8_t add,uint8_t reg,uint8_t* p,uint8_t len);
bool IIC_FRONT_ReadBytes(uint8_t add,uint8_t reg,uint8_t* p,uint8_t len);


#endif
