#ifndef __hal_led_h__
#define __hal_led_h__
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"

//ARGB
//#define COLOR_BLACK					0xFF000000
//#define COLOR_WHITE					0xFF070707
//#define COLOR_RED		  			0xFF070000
//#define COLOR_GREEN					0xFF000700
//#define COLOR_BLUE					0xFF000007
//#define COLOR_ORANGE				0xFF070300
//#define COLOR_PURPLE				0xFF070007
//#define COLOR_YELLOW				0xFF070700
//#define COLOR_CYAN					0xFF000707

//#define COLOR_BLACK		0xFF000000
//#define COLOR_WHITE		0xFFFFFFFF
//#define COLOR_RED		  0xFFFF0000
//#define COLOR_GREEN		0xFF00FF00
//#define COLOR_BLUE		0xFF0000FF
//#define COLOR_ORANGE	0xFFFF6000
//#define COLOR_PURPLE	0xFFFF00FF
//#define COLOR_YELLOW	0xFFFFFF00
//#define COLOR_CYAN		0xFF00FFFF


//#define COLOR_BLACK                0xFF000000
//#define COLOR_LOWWHITE             0x0F0F0F0F
//#define COLOR_WHITE                0x2F2F2F2F
//#define COLOR_RED                  0xFFFF0000
//#define COLOR_LIGHRED              0xFF070000
//#define COLOR_GREEN                0xFF007F00
//#define COLOR_BLUE                 0xFF0000FF
//#define COLOR_ORANGE               0xFF6F1000
//#define COLOR_PURPLE               0xFFFF00FF
//#define COLOR_YELLOW               0xFFFFFF00
//#define COLOR_CYAN                 0xFF000707

//#define COLOR_BLACK					0xFF000000
//#define COLOR_LOWWHITE      0x0F0F0F0F
//#define COLOR_WHITE					0xFF0E0E0E
//#define COLOR_RED		  			0xFF2F0000
//#define COLOR_GREEN					0xFF002F00
//#define COLOR_BLUE					0xFF00002F
//#define COLOR_ORANGE				0xFF1F1000
//#define COLOR_PURPLE				0xFF2F002F
//#define COLOR_YELLOW				0xFF5F5F00
//#define COLOR_CYAN					0xFF005F5F

#define COLOR_BLACK					0xFF000000
#define COLOR_LOWWHITE      0x0F0F0F0F
#define COLOR_WHITE					0xFF1F1F1F
#define COLOR_RED		  			0xFF6F0000
#define COLOR_GREEN					0xFF009F00
#define COLOR_BLUE					0xFF0000AF
#define COLOR_ORANGE				0xFF3F1000
#define COLOR_PURPLE				0xFF9F009F
#define COLOR_YELLOW				0xFF7F7F00
#define COLOR_CYAN					0xFF005F5F

#define LED_ENABLE						0
#define LED_DISABLE						1


////ʾȼ 0~250
//enum {
//	LED_PRIO_NONE = 0,	//
//	LED_PRIO_OVERTURN,	//תʾ
//	LED_PRIO_CHARGE,	//ʾ
//	
//};	

//ʾȼ 0~250
enum {
	LED_NONE = 0,	  //
	LED_RUN,		    //Ե
	LED_CONNECT,	  //ɵ
	LED_SELF_CHECK,	//Լ
	LED_OVERTURN,	  //תʾ
	LED_CHARGE,		  //ʾ
	LED_LRCHECK,    //Ьֵ
	LED_PAIR,       //ƥɵ 
	LED_EXCEPT,     //ϵ
	LED_NUM_OF_LED,	//LEDԱ
};

void LED_Init(void);
void LED_Stop(uint8_t n);
void LED_Start(uint8_t n,uint32_t color);
void LED_Close_Enforce(void);
void LED_SetColor(uint8_t n,uint32_t color);

void WS2812_DisplayDot(uint32_t col);
void WS2812_Pwm_Play(void);

#endif



